searchNodes=[{"doc":"Use LEDs for your user interface delux simplifies creating and running LED blink patterns for use as part of a user interface for an embedded hardware. This library provides: Low overhead LED control via Linux's Sysclass interface - blink sequences get compiled down so that they can be run inside the Linux kernel. Built-in LED effects for common use cases like blinking, cycling LED colors, etc. Prioritization of LED effects Support for many physical LED configurations Nice textual descriptions of what the LED is doing to support remote debug This library is primarily intended for devices with 1 to 10 LEDs. It's currently not for Neopixels and other &quot;smart&quot; LEDs that are more typically found in larger numbers, but could be used for a similar purpose. Before diving in, some terminology is needed: LED - one light emitting element. This doesn't have to be an LED, but the Linux kernel must think that it is and show a directory for it under /sys/class/leds/ . Indicator - a group of 1, 2, or 3 LEDs that a user would perceive as one. This could be a lone green LED, or a red, green and blue LED in one package, or any combination. Program - a one-time or repeating set of instructions for controlling an indicator. Pattern - a low-level sequence of brightness and duration tuples for controlling one LED Program priority - a user-provided name that determines which program is run when multiple are scheduled. For example, a program that gives the user feedback for pressing a button could take precedence over a program showing network connection status To give a flavor of how delux works, here's an example that configures delux with one green LED and then blinks it at 2 Hz: iex&gt; { :ok , pid } = Delux . start_link ( indicators : %{ default : %{ green : &quot;led0&quot; } } ) iex&gt; Delux . render ( pid , Delux.Effects . blink ( :green , 2 ) ) iex&gt; Delux . info ( pid ) green at 2 Hz This starts Delux with one indicator, :default , that has a green LED known to Linux as &quot;led0&quot; . The Delux.Effects.blink/3 function creates a 2 Hz blinking program for Delux to render. With nothing else specified, Delux.render/2 runs the program on the default indicator at the default priority.","ref":"Delux.html","title":"Delux","type":"module"},{"doc":"Adjust the overall brightness of all indicators Effects are adjusted based on the value passed. NOTE: This is not fully supported yet!","ref":"Delux.html#adjust_brightness/2","title":"Delux.adjust_brightness/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Delux.html#child_spec/1","title":"Delux.child_spec/1","type":"function"},{"doc":"Clear out any programs set at the specified priority If this means that no programs at any priority are set, the indicator is turned off.","ref":"Delux.html#clear/2","title":"Delux.clear/2","type":"function"},{"doc":"Print out info about an indicator This is handy when you can't physically see an indicator. It's intended for users at the IEx prompt. For programmatic use, see info_as_ansidata/2 .","ref":"Delux.html#info/2","title":"Delux.info/2","type":"function"},{"doc":"Return user-readable information about an indicator","ref":"Delux.html#info_as_ansidata/2","title":"Delux.info_as_ansidata/2","type":"function"},{"doc":"Update one or more indicators to a new program Passing nil for the program removes the program running at the specified priority. This is the same as calling clear/2 .","ref":"Delux.html#render/3","title":"Delux.render/3","type":"function"},{"doc":"Start an Delux GenServer See t:options() for configuration options","ref":"Delux.html#start_link/1","title":"Delux.start_link/1","type":"function"},{"doc":"Configuration for an indicator Specify the Linux LED name for each LED. Single LED indicators should use a color that's close or just choose :red .","ref":"Delux.html#t:indicator_config/0","title":"Delux.indicator_config/0","type":"type"},{"doc":"The name for one indicator An indicator may be composed of multiple LEDs, but they're arranged such that it looks like one light source to someone looking at it. For example, an RGB LED has 3 LEDs inside of it. These can be anything you want. If you don't explicitly specify indicator names, an indicator named :default is used.","ref":"Delux.html#t:indicator_name/0","title":"Delux.indicator_name/0","type":"type"},{"doc":"Delux configuration options :led_path - the path to the LED directories (defaults to &quot;/sys/class/leds&quot; ) :priorities - a list of priority atoms from lowest to highest. Defaults to [:status, :notification, :user_feedback] :indicators - a map of indicator names to their configurations :name - if specified, this is passed to GenServer.start_link/3 so register the name of the Delux GenServer","ref":"Delux.html#t:options/0","title":"Delux.options/0","type":"type"},{"doc":"Priority of an indicator program Priorities determine which program is rendered when more than one can be shown at the same time. The default priority is :status which is also the lowest priority. The :notification and :user_feedback priorities are higher. For example, rendering visual feedback to the user pressing a button can be assigned to the :user_feedback priority so the user knows that the button pressed worked regardless of what else is happening.","ref":"Delux.html#t:priority/0","title":"Delux.priority/0","type":"type"},{"doc":"Functions for creating a variety of LED patterns","ref":"Delux.Effects.html","title":"Delux.Effects","type":"module"},{"doc":"Blink an indicator This returns a pattern that blinks the specified color at a 50% duty cycle. The pattern starts on and then goes off.","ref":"Delux.Effects.html#blink/3","title":"Delux.Effects.blink/3","type":"function"},{"doc":"Create a transient two color sequence The first color is shown for 20 ms. 10 ms in, the second color is shown for 20 ms. The Effects is a quick flash of light that can be used to show feedback to a button. Total duration of the Effects is 40 ms.","ref":"Delux.Effects.html#blip/3","title":"Delux.Effects.blip/3","type":"function"},{"doc":"Cycle between colors Colors are shown with equal duration determined from the specified frequency.","ref":"Delux.Effects.html#cycle/3","title":"Delux.Effects.cycle/3","type":"function"},{"doc":"All LEDs off","ref":"Delux.Effects.html#off/0","title":"Delux.Effects.off/0","type":"function"},{"doc":"Set an indicator to the specified color","ref":"Delux.Effects.html#on/2","title":"Delux.Effects.on/2","type":"function"},{"doc":"Create a program from an arbitrary function Pass in a function that takes times in milliseconds and returns colors. The returned pattern piecewise linearly interpolates the waveform. Here's an example of a 0.5 Hz blue sine wave: Effects . waveform ( fn t -&gt; { 0 , 0 , 0.5 + 0.5 * :math . cos ( :math . pi ( ) * t / 1000 ) } end , 2000 ) When trying this, keep in mind that if the LEDs in the indicator don't support varying levels of brightness, it won't look like a sine wave. Options :time_step - the number of milliseconds between each sample. Defaults to 100 ms.","ref":"Delux.Effects.html#waveform/3","title":"Delux.Effects.waveform/3","type":"function"},{"doc":"Option effects (none yet)","ref":"Delux.Effects.html#t:options/0","title":"Delux.Effects.options/0","type":"type"},{"doc":"Functions for Morse code patterns","ref":"Delux.Morse.html","title":"Delux.Morse","type":"module"},{"doc":"Convert a string to an indicator program Options: :words_per_minute - the rate at which to send the message","ref":"Delux.Morse.html#encode/3","title":"Delux.Morse.encode/3","type":"function"},{"doc":"","ref":"Delux.Morse.html#t:options/0","title":"Delux.Morse.options/0","type":"type"},{"doc":"Utility functions for handling element sequences for one LED","ref":"Delux.Pattern.html","title":"Delux.Pattern","type":"module"},{"doc":"PWM a sequence of elements The resulting sequence will only be fully on or fully off. See caveats in Program.adjust_brightness_pwm/2 . IMPORTANT: This function is VERY incomplete right now. It requires much more thought to work around flickering issues at low PWM rates.","ref":"Delux.Pattern.html#pwm/2","title":"Delux.Pattern.pwm/2","type":"function"},{"doc":"Reduce the number of transitions in a sequence This reduces the length of the pattern and in some cases makes it use less of the CPU to run. It's useful for programmatically generated patterns that can take inputs that generate lots of repeating sequences.","ref":"Delux.Pattern.html#simplify/1","title":"Delux.Pattern.simplify/1","type":"function"},{"doc":"Convert a pattern to iodata","ref":"Delux.Pattern.html#to_iodata/2","title":"Delux.Pattern.to_iodata/2","type":"function"},{"doc":"Value, duration for one component Values are 0 to 1 and durations are in milliseconds.","ref":"Delux.Pattern.html#t:element/0","title":"Delux.Pattern.element/0","type":"type"},{"doc":"Integer durations in milliseconds","ref":"Delux.Pattern.html#t:milliseconds/0","title":"Delux.Pattern.milliseconds/0","type":"type"},{"doc":"A sequence of elements These get processed into the pattern string that's sent to Linux.","ref":"Delux.Pattern.html#t:t/0","title":"Delux.Pattern.t/0","type":"type"},{"doc":"Create LED patterns See https://elixir.bootlin.com/linux/latest/source/Documentation/devicetree/bindings/leds/leds-trigger-pattern.txt","ref":"Delux.Program.html","title":"Delux.Program","type":"module"},{"doc":"Adjust the brightness of a pattern This modifies the pattern to optionally dim it by blinking the LED at 50 Hz. It is not an efficient way of dimming LEDs since the blinking is done on the processor by the kernel.","ref":"Delux.Program.html#adjust_brightness_pwm/2","title":"Delux.Program.adjust_brightness_pwm/2","type":"function"},{"doc":"Return a description with nice ANSI colors The description is returned as IO.ANSI.ansidata() . Use IO.ANSI.format/1 to expect escape codes for display with IO.puts/1 .","ref":"Delux.Program.html#ansi_description/1","title":"Delux.Program.ansi_description/1","type":"function"},{"doc":"Reduce the number of transitions in a pattern This reduces the length of the pattern and in some cases makes it use less of the CPU to run. It's useful for programmatically generated patterns that can take inputs that generate lots of repeating sequences.","ref":"Delux.Program.html#simplify/1","title":"Delux.Program.simplify/1","type":"function"},{"doc":"Return an unformatted description of the pattern See ansi_description/1 for colorized description","ref":"Delux.Program.html#text_description/1","title":"Delux.Program.text_description/1","type":"function"},{"doc":"Program information for one indicator","ref":"Delux.Program.html#t:t/0","title":"Delux.Program.t/0","type":"type"},{"doc":"Utilities for RGB tuples","ref":"Delux.RGB.html","title":"Delux.RGB","type":"module"},{"doc":"Create a new RGB tuple You can pass in a tuple or a color name.","ref":"Delux.RGB.html#new/1","title":"Delux.RGB.new/1","type":"function"},{"doc":"Convert a color to a human-readable ansidata iex&gt; RGB . to_ansidata ( :red , &quot;This is &quot; ) [ :red , &quot;This is &quot; , &quot;red&quot; ] iex&gt; RGB . to_ansidata ( { 0 , 0.5 , 1 } , &quot;This is &quot; ) [ &quot;This is &quot; , &quot;{0, 0.5, 1}&quot; ]","ref":"Delux.RGB.html#to_ansidata/2","title":"Delux.RGB.to_ansidata/2","type":"function"},{"doc":"","ref":"Delux.RGB.html#t:color/0","title":"Delux.RGB.color/0","type":"type"},{"doc":"Colors components go from 0 (off) to 1 (brightest)","ref":"Delux.RGB.html#t:component/0","title":"Delux.RGB.component/0","type":"type"},{"doc":"An RGB triplet Note that accuracy of the color depends on the LEDs in use. The color should be recognizable, but Delux doesn't support calibration.","ref":"Delux.RGB.html#t:t/0","title":"Delux.RGB.t/0","type":"type"},{"doc":"de lux | Latin (roughly) for &quot;of the light&quot; Use LEDs for your user interface delux simplifies creating and running LED blink patterns for use as part of a user interface for an embedded hardware. This library provides: Low overhead LED control via Linux's Sysclass interface - blink sequences get compiled down so that they can be run inside the Linux kernel. Built-in LED effects for common use cases like blinking, cycling LED colors, etc. Prioritization of LED effects Support for many physical LED configurations Nice textual descriptions of what the LED is doing to support remote debug This library is primarily intended for devices with 1 to 10 LEDs. It's currently not for Neopixels and other &quot;smart&quot; LEDs that are more typically found in larger numbers, but could be used for a similar purpose. Before diving in, some terminology is needed: LED - one light emitting element. This doesn't have to be an LED, but the Linux kernel must think that it is and show a directory for it under /sys/class/leds/ . Indicator - a group of 1, 2, or 3 LEDs that a user would perceive as one. This could be a lone green LED, or a red, green and blue LED in one package, or any combination. Program - a one-time or repeating set of instructions for controlling an indicator. Pattern - a low-level sequence of brightness and duration tuples for controlling one LED Program priority - a user-provided name that determines which program is run when multiple are scheduled. For example, a program that gives the user feedback for pressing a button could take precedence over a program showing network connection status To give a flavor of how delux works, here's an example that configures delux with one green LED and then blinks it at 2 Hz: iex&gt; { :ok , pid } = Delux . start_link ( indicators : %{ default : %{ green : &quot;led0&quot; } } ) iex&gt; Delux . render ( pid , Delux.Effects . blink ( :green , 2 ) ) iex&gt; Delux . info ( pid ) green at 2 Hz This starts Delux with one indicator, :default , that has a green LED known to Linux as &quot;led0&quot; . The Delux.Effects.blink/3 function creates a 2 Hz blinking program for Delux to render. With nothing else specified, Delux.render/2 runs the program on the default indicator at the default priority.","ref":"readme.html","title":"💡 delux 💡","type":"extras"},{"doc":"delux comes with helper functions for creating LED programs. It's also possible to create your own. Here are the built-in ones: Function Description Delux.Effects.off/0 Turn an indicator off Delux.Effects.on/2 Set the indicator to the specified color (within reason, that is. You can't make a green LED red, for example.) Delux.Effects.blink/3 Blink a color on and off at a fixed rate Delux.Effects.blip/3 Show two colors quickly in succession. E.g., use to show feedback from pressing a button. Delux.Effects.cycle/3 Cycle through a set of colors at a fixed rate Delux.Effects.waveform/2 Synthesize an LED pattern from a function Delux.Morse.encode/3 Send a string in Morse code","ref":"readme.html#built-in-indicator-programs","title":"💡 delux 💡 - Built-in indicator programs","type":"extras"},{"doc":"It's worthwhile thinking about how you want your device's LEDs to behave before writing any code. The first step is to figure out what LEDs are available and how to group them into indicators. To see what's available, list the directories in /sys/class/leds . If something is missing, you'll likely need to adjust the device tree configuration and make it appear. That's discussed somewhat below, but this is device-specific, so you'll need to look elsewhere for precise guides. After you've found the LEDs, group them and give them indicator names. If you just have one indicator, call it :default . That will make delux 's API more convenient. Step 2 is to decide what priorities make sense for your application. Only one program per indicator can be run at a time. Every time that you set a program on an indicator, it replaces any running programs for that indicator at that priority. The default priorities probably suffice to start: :status - The lowest priority. This is for general device status like whether networking is working and if the device is initializing and connected to the back end. :notification - This is a medium priority. Use it to show transient things like an alert that requires operator attention to clear. :user_feedback - This is the highest priority and for showing feedback to a user. For example, it could blink the LED when user pushes a button so they know that the device is doing something. Clearing the program at one priority makes delux render the program on the next lower priority or if there's no program, then the indicator is turned off. Sometimes adding priorities can remove the need to write state machine code. Once you feel good about the indicators and priority levels, it's time to configure delux .","ref":"readme.html#before-you-use-delux","title":"💡 delux 💡 - Before you use delux","type":"extras"},{"doc":"After adding delux to your mix dependencies, add Delux to a supervision tree of your choice. The childspec looks like: { Delux , name : MyIndicators , indicators : %{ default : %{ red : &quot;led0:red&quot; , green : &quot;led0:green&quot; , blue : &quot;led0:blue&quot; } , indicator2 : %{ red : &quot;led1&quot; } } } The above configuration shows two indicators. The first is called :default and is an RGB indicator. The second is a lone red LED that's used as :indicator2 . As mentioned before, if you only have one indicator, call it :default . Other options include setting the list of priorities and giving the Delux GenServer a name. Those are optional.","ref":"readme.html#configuration","title":"💡 delux 💡 - Configuration","type":"extras"},{"doc":"After you have a Delux GenServer and running, call Delux.render/2 to turn on the default indicator on the default priority: iex&gt; Delux . render ( MyIndicators , Delux.Effects . on ( :white ) ) :ok Even if you don't have an RGB indicator, passing :white should turn on all of the LEDs that you do have. If you have two indicators and want them to blink back and forth, you can try this: iex&gt; Delux . render ( MyIndicators , %{ default : Delux.Effects . cycle ( [ :black , :white ] , 1 ) , indicator2 : Delux.Effects . cycle ( [ :white , :black ] , 1 ) } ) :ok Finally, pass a third parameter to Delux.render/3 to assign the programs to another priority.","ref":"readme.html#use","title":"💡 delux 💡 - Use","type":"extras"},{"doc":"Indicator programs are a collection of LED patterns and metadata as defined by the Delux.Program struct. The helper functions in Delux.Effects and Delux.Morse create these and can be used as examples. The core of the program is an Delux.Pattern . There are three patterns per program for each of the color channels. Each pattern is a list of {value, duration} tuples where value is a number from 0 to 1 and duration is an integer number of milliseconds. While delux internally holds a number from 0 (off) to 1 (full on) for the LED's value at that point in time, this gets scaled to an integer when sent to Linux. This integer depends on the maximum brightness value for an LED. This is often just 1 since Linux can only turn the LED off and on. Sometimes Linux can set the LED to multiple levels and in those cases, the maximum value will be greater than 1 (often 255). You don't need to worry about scaling other than to be aware that fractional values will be rounded when sent to Linux and this will mess up colors. Linux interpolates the LED value over the duration between pairs of tuples. A common idiom is to have 0 duration tuples to turn off interpolation. For example, [{1, 100}, {1, 0}, {0, 100}, {0, 0}] turns the LED on for 100 ms and then off for 100 ms without any interpolation. See Linux's LED pattern trigger documentation at leds-trigger-pattern.txt for more info.","ref":"readme.html#creating-your-own-programs","title":"💡 delux 💡 - Creating your own programs","type":"extras"},{"doc":"delux works in all official Nerves systems. If not using Nerves, you will need to have CONFIG_LEDS_TRIGGER_PATTERN=y enabled your Linux kernel configuration. The second step to using Linux's LED subsystem is to configure LEDs in the device tree. You can't just use an arbitrary GPIO to turn on the LED like you can with Circuits.GPIO . Linux needs to know about the GPIO. It's also possible to hook up PWMs and LED drivers. See the LED drivers for options. The following is an example device tree configuration for telling Linux about GPIO-connected LEDs. It is platform-specific so you can't just copy/paste it. It sets up two RGB LEDs and makes one blink early in the boot process. / { leds { pinctrl-names = &quot;default&quot;; pinctrl-0 = &lt;&amp;pinctrl_leds&gt;; compatible = &quot;gpio-leds&quot;; led1_red { label = &quot;led1:red&quot;; gpios = &lt;&amp;pio 0 7 GPIO_ACTIVE_LOW&gt;; }; led1_green { label = &quot;led1:green&quot;; gpios = &lt;&amp;pio 4 15 GPIO_ACTIVE_LOW&gt;; }; led1_blue { label = &quot;led1:blue&quot;; gpios = &lt;&amp;pio 4 4 GPIO_ACTIVE_LOW&gt;; /* Blink LED at 2 Hz (250 ms on, off) */ linux,default-trigger = &quot;timer&quot;; default-state = &quot;on&quot;; led-pattern = &lt;250 250&gt;; }; led2_red { label = &quot;led2:red&quot;; gpios = &lt;&amp;pio 4 5 GPIO_ACTIVE_LOW&gt;; }; led2_green { label = &quot;led2:green&quot;; gpios = &lt;&amp;pio 4 14 GPIO_ACTIVE_LOW&gt;; }; led2_blue { label = &quot;led2:blue&quot;; gpios = &lt;&amp;pio 4 7 GPIO_ACTIVE_LOW&gt;; }; }; };","ref":"readme.html#linux-kernel-configuration","title":"💡 delux 💡 - Linux kernel configuration","type":"extras"},{"doc":"Copyright (C) 2022 SmartRent Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0) Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"💡 delux 💡 - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changes Fix typespecs to remove warnings found by Dialyzer Update Delux.Effects.waveform/3 to support color atom names and check RGB tuples for range. The latter fixes errors that get detected later on and are more confusing to figure out.","ref":"changelog.html#v0-1-3-2022-08-11","title":"Changelog - v0.1.3 - 2022-08-11","type":"extras"},{"doc":"Changes Improve Delux.Effects.waveform/3 so that it's easier to use and produces shorter patterns. It now has examples in the docs and unit tests.","ref":"changelog.html#v0-1-2-2022-08-11","title":"Changelog - v0.1.2 - 2022-08-11","type":"extras"},{"doc":"Changes Adjust timed pattern playback to minimize trimming LED programs. Unfortunately, LED programs still get cut off at the end with this release. If you're using Morse code, you'll see this. We plan on fixing this completely in a future release. Support empty LED setups to simplify configuration of multi-target projects and unit tests.","ref":"changelog.html#v0-1-1-2022-08-10","title":"Changelog - v0.1.1 - 2022-08-10","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2022-08-08","title":"Changelog - v0.1.0 - 2022-08-08","type":"extras"}]